// Vars
var cpd = 1000; // <-- The Cost Per Day for the guests
var new_cpd = 1000;
var rooms = 0;
var guests = 0;
var views = 0;
var rooms_p = 100;
var rooms_g = 1;
var views_p = 100;
var views_g = 4;
var money = 5000;
var upgrade = 1;
var dayload;

// raw code

if (!localStorage["game"]) {
    // init variable/set default variable for item
    new_game();
}else{
	load_game();
}

// Functions
function new_game() {
	cpd = 1000;
	new_cpd = 1000;
	rooms = 0;
	guests = 0;
	views = 0;
	rooms_p = 100;
	rooms_g = 1;
	views_p = 100;
	views_g = 4;
	money = 5000;
	upgrade = 1;

	activate_button();
	draw();
	drawu();
	dayload = setInterval(day, 2000);
}

function save_game(){
	localStorage.cpd = cpd;
	localStorage.new_cpd = new_cpd;
	localStorage.rooms = rooms;
	localStorage.guests = guests;
	localStorage.views = views;
	localStorage.rooms_p = rooms_p;
	localStorage.rooms_g = rooms_g;
	localStorage.views_p = views_p;
	localStorage.views_g = views_g;
	localStorage.money = money;
	localStorage.upgrade = upgrade;
	localStorage.game = true;
}

function load_game() {
	cpd = parseInt(localStorage.cpd);
	new_cpd = parseInt(localStorage.new_cpd);
	rooms = parseInt(localStorage.rooms);
	guests = parseInt(localStorage.guests);
	views = parseInt(localStorage.views);
	rooms_p = parseInt(localStorage.rooms_p);
	rooms_g = parseInt(localStorage.rooms_g);
	views_p = parseInt(localStorage.views_p);
	views_g = parseInt(localStorage.views_g);
	money = parseInt(localStorage.money);
	upgrade = parseInt(localStorage.upgrade);

	activate_button();
	draw();
	drawu();
	if (upgrade > 1) {
		$("#multiplier").show();
		$('#upgrade_r_i').html("$" + display_number(rooms_p) + " | " + display_number(rooms_g));
		$('#upgrade_v_i').html("$" + display_number(views_p) + " | " + display_number(views_g));
	}
	if (upgrade >= 10) {
		$('#sell_div').show();
	}
	if (upgrade >= 12) {
		$('#finances').show();
	}
	dayload = setInterval(day, 2000);
}

function day(){
	 // <-- you earn from the day befor
	if (money + guests*new_cpd <= (50000*Math.pow(2, upgrade))*10) {
		money += guests*new_cpd;
	}
	money -= rooms*(rooms_p/rooms_g)*0.001;
	money -= views*(views_p/views_g)*0.001;

	// Add the new guests
	guests = Math.round(Math.floor(Math.random() * guests/cpd) + 0);
	guests += Math.round(Math.floor(Math.random() * getPotentialGuests()) + getPotentialGuests()/2);
	if (guests > rooms) {
		//views -= guests-rooms;
		guests = rooms;
	}
	if (views < 0) {
			views = 0;
	}
	if (finances) {
		$('#Finances_body').html('');
		$('#Finances_body').append('Cost for Rooms: <p class="text-danger">-' + display_number(rooms*(rooms_p/rooms_g)*0.001) + '</p> <br>');
		$('#Finances_body').append('Cost for Ads: <p class="text-danger">-' + display_number(views*(views_p/views_g)*0.001) + '</p> <br>');
		$('#Finances_body').append('Cost for Cleaning: <p class="text-danger">-' + display_number(guests*(cpd/2)) + '</p> <br>');
		$('#Finances_body').append('Money from Guests: <p class="text-success">+' + display_number(guests*new_cpd) + '</p> <br>');
		if ((rooms*(rooms_p/rooms_g)*0.001 + views*(views_p/views_g)*0.001 + guests*(cpd/2)) - guests*new_cpd < 0) {
			$('#Finances_body').append('Total: <p class="text-success">+' + display_number(((rooms*(rooms_p/rooms_g)*0.001 + views*(views_p/views_g)*0.001 + guests*(cpd/2)) - guests*new_cpd) * -1) + '</p> <br>');
		}else{
			$('#Finances_body').append('Total: <p class="text-danger">-' + display_number(((rooms*(rooms_p/rooms_g)*0.001 + views*(views_p/views_g)*0.001 + guests*(cpd/2)) - guests*new_cpd)) + '</p> <br>');
		}
	}
	// add the new cpd
	new_cpd = cpd;

	money -= guests*(cpd/2);

	activate_button();
	draw();
	save_game();
}

function getPotentialGuests(){
	return views*upgrade*Math.pow(0.954992586, cpd);
	//return views/(cpd*upgrade);
}

function upgrade_star(){
	if (money >= 50000*Math.pow(2, upgrade)) {
		money -= (50000*Math.pow(2, upgrade));
		upgrade++;
		
		views_p = 100*upgrade;
		views_g = 4;

		rooms_p = 100*upgrade;
		rooms_g = 1;

		//views = 0;
		guests = 0;
		//rooms = 0;

		draw();
		drawu();
		if (upgrade == 2) {
			$('#multiplier').show();
		}
		if (upgrade == 10) {
			$('#sell_div').show();
		}
		if (upgrade == 12) {
			$('#finances').show();
		}
		$('#upgrade_r_i').html("$" + display_number(rooms_p) + " | " + display_number(rooms_g));
		$('#upgrade_v_i').html("$" + display_number(views_p) + " | " + display_number(views_g));

		//}
		
	}
}

function activate_button(){
	if (rooms_p > money) {
		$("#upgrade_r").attr("data-background-color", "grey");
	}else{
		$("#upgrade_r").attr("data-background-color", "orange");
	}
	if (money <= 0) {
		$("#money_display").attr("data-background-color", "grey");
	}else{
		$("#money_display").attr("data-background-color", "green");
	}
	if (views_p > money) {
		$("#upgrade_v").attr("data-background-color", "grey");
	}else{
		$("#upgrade_v").attr("data-background-color", "blue");
	}
	if (guests == rooms) {
		$("#upgrade_icon").attr("class", "material-icons text-danger");
	}else if (guests == 0) {
		$("#upgrade_icon").attr("class", "material-icons text-danger");
	}else{
		$("#upgrade_icon").attr("class", "material-icons");
	}
}

function draw(){
	$('#draw_rooms').html(display_number(guests) + "/" + display_number(rooms));
	$('#draw_money').html("$" + display_number(money));
	$('#draw_views').html(display_number(views));
	$('#upgrade').html('Upgrade Hotel: $' + (display_number(50000*Math.pow(2, upgrade))));
	$('#sell_btn').html('Sell Hotel: +$' + display_number(money));
}

function drawu(){
	$('#star').html('');
	stars = 0;
	if (upgrade > 10) {
		$('#star').append('<i class="material-icons md-light md-inactive">star</i>x' + upgrade/2);
	}else{
		while(stars != 10){
			if (stars < upgrade) {
				if (stars+1 < upgrade) {
					$('#star').append('<i class="material-icons md-light md-inactive">star</i>');
					stars++;
				}else{
					$('#star').append('<i class="material-icons md-light md-inactive">star_half</i>');
					stars++;
				}
			}else{
				$('#star').append('<i class="material-icons md-light md-inactive">star_border</i>');
				stars++;
			}
			stars++;
		}
	}
}

function mal2(){
	rooms_p *= 2;
	rooms_g *= 2;
	views_p *= 2;
	views_g *= 2;

	activate_button();
	$('#upgrade_r_i').html("$" + display_number(rooms_p) + " | " + display_number(rooms_g));
	$('#upgrade_v_i').html("$" + display_number(views_p) + " | " + display_number(views_g));
}
function durch2(){
	if (rooms_g / 2 >= 1) {
		rooms_p /= 2;
		rooms_g /= 2;
		views_p /= 2;
		views_g /= 2;

		activate_button();
		$('#upgrade_r_i').html("$" + display_number(rooms_p) + " | " + display_number(rooms_g));
		$('#upgrade_v_i').html("$" + display_number(views_p) + " | " + display_number(views_g));
	}
}

function sell_hotel(){
	clearInterval(dayload);

	cpd = 1000;
	new_cpd = 1000;
	rooms = 0;
	guests = 0;
	views = 0;
	rooms_p = 100;
	rooms_g = 1;
	views_p = 100;
	views_g = 4;
	upgrade = 1;

	activate_button();
	draw();
	drawu();
	dayload = setInterval(day, 2000);
	$('#sell_div').hide();
}

function display_number(x){
	var add = "";
	if(x > Math.pow(10, 19)){
		x = x / Math.pow(10, 18);
		add = "<small>trillion</small>";
	}else if(x > Math.pow(10, 16)){
		x = x / Math.pow(10, 15);
		add = "<small>billiard</small>";
	}else if(x > Math.pow(10, 13)){
		x = x / Math.pow(10, 12);
		add = "<small>billion</small>";
	}else if(x > Math.pow(10, 10)){
		x = x / Math.pow(10, 9);
		add = "<small>milliard</small>";
	}else if(x > Math.pow(10, 7)){
		x = x / Math.pow(10, 6);
		add = "<small>million</small>";
	}


	if (add != "") {
		return "" + x.toLocaleString('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }) + add;
	}else{
		return "" + x.toLocaleString('de-DE', { minimumFractionDigits: 0, maximumFractionDigits: 0 });
	}
	
}

// EVENT Listeners
$('#cpd_input').on('change', function() {
	if ($(this).val() > 0) {
		cpd = Math.round($(this).val());
		$(this).val(cpd);
	}else{
		$(this).val(cpd);
	}
});

$('#cpd_input').on('click', function() {
	$(this).val(cpd);
});

function upgrade_r() {
	if (rooms_p <= money) {
		rooms += rooms_g;
		money -= rooms_p;
		activate_button();
		draw();
	}
};

function upgrade_v() {
	if (views_p <= money) {
		views += views_g;
		money -= views_p;
		activate_button();
		draw();
	}
};